/*
 * 4.1.1. Alocarea dinamic. Opertorii new si delete.
 *
 *                                  Se  utilizeaza clasa intErval.
 * Pentru link-editare este necesar fisierul proiect ALOCDINA.PRJ.
 */

#include <iostream.h>
#include "intErval.h"

int main( ) {
  // Operatorul new are ca argumente numele unui tip T
  // (predefinit sau definit de utilizator) si dimensiunea
  // zonei care va fi alocata. Valoarea returnata este de
  // tip "pointer la T". Operatorul new returneaza 0 in
  // cazul in care alocarea nu a fost posibila.

  // se aloca o zona de 2048 de intregi
  int *pi = new int [ 2048 ];

  // se aloca o zona de 64 de elemente de tip
  // intErval cu domeniul implicit
  intErval *pi_m = new intErval [ 64 ];

  // se aloca o zona de 8192 de elemente de tip float
  float *pf = new float [ 8192 ];


  // De asemenea, operatorul new poate fi folosit pentru
  // alocarea unui singur element de un anumit tip T,
  // precizand eventual si argumentele constructorului
  // tipului respectiv.

  // se aloca un intreg initializat cu 8
  int *i = new int( 8 );

  // se aloca un element de tip intErval
  // cu domeniul admisibil -16, ..., 15
  intErval *m = new intErval( 16, -16 );

  // se aloca un numar real (float) initializat cu 32
  float *f = new float( 32 );


  // Zonele alocate pot fi eliberate oricand si in orice
  // ordine, dar numai prin intermediul pointerului
  // returnat de operatorul new.

  delete [ ] pf;
  delete [ ] pi;
  delete i;
  delete f;
  delete [ ] pi_m;
  delete m;

  return 0;
}

