/*
 * 6.9. Algoritmul lui Dijkstra.
 */

#include <iostream.h>
#include <values.h>

#include "tablou.h"
#include "heap.h"
#include "muchie.h"
#include "lista.h"
#include "vp.h"

typedef tablou< lista<vp> > graf;

tablou<vp> Dijkstra( const graf& G, int m, int s ) {
  int n = G.size( );  // numarul de varfuri ale grafului G

  heap<vp> C( n + m );
  tablou<vp> P( n );

  vp v, w;   // muchii
  float dw;  // distanta

  // initializare
  for ( int i = 0; i < n; i++ )
    P[ i ]( s, MAXFLOAT );
  for ( iterator<vp> g = G[ s ]; g( w ); )
    C.insert( w ); P[ w ]( s, w );
  P[ s ]( 0, 0 );

  // bucla greedy
  for ( i = 1; i < n - 1; i++ ) {
    C.delete_max( v ); g = G[ v ];
    while ( g( w ) )
      if ( (float)P[ w ] > ( dw = (float)P[ v ] + (float)w ) )
        C.insert( vp( w, P[ w ]( v, dw ) ) );
  }
  return P;
}

main( ) {
  int n, m = 0;  // #varfuri si #muchii
  muchie M;

  cout << "Numarul de varfuri... "; cin >> n;
  graf G( n );

  cout << "Muchiile... ";
  while( cin >> M ) {
    // aici se poate verifica corectitudinea muchei M
    G[ M.u ].insert( vp( M.v, M.cost ) );
    m++;
  }

  cout << "\nListele de adiacenta:\n"; cout << G << '\n';

  for ( int s = 0; s < n; s++ ) {
    cout << "\nCele mai scurte drumuri de la varful "
         << (s + 1) << " sunt:\n";
    cout << Dijkstra( G, m, s ) << '\n';
  }

  return 0;
}