/*
 * 10.1. Ciurul lui Eratostene. Un exemplu de utilizare a listelor.
 */

#include <iostream.h>
#include <stdlib.h>
#include <new.h>


class element {
public:
  element( element *src ) { sursa = src; }
  virtual int cerne( ) { return 0; }

protected:
  element *sursa;
};

class contor: public element {
public:
  contor( int v ): element( 0 ) { valoare = v; }
  int cerne( ) { return valoare++; };

private:
  int valoare;
};

class ciur: public element {
public:
  ciur( element *src ): element( src ) { }
  int cerne( );
};

class sita: public element {
public:
  sita( element *src, int f ): element(src) { factor = f; }
  int cerne( );

private:
  int factor;
};

int sita::cerne( ) {
  while ( 1 ) {
    int n = sursa->cerne( );
    if ( n % factor ) return n;
  }
}

int ciur::cerne( ) {
 int n = sursa->cerne( );
 sursa = new sita( sursa, n );
 return n;
}


void no_mem( ) { cerr << "no_mem"; exit( 1 ); }
extern unsigned _stklen = 32 * 1024;

int main( ) {
  _new_handler = no_mem;

  int max;
  cout << "max ... "; cin >> max;

  ciur s( &contor( 2 ) );
  int prim;

  do {
    prim = s.cerne( );
    cout << prim << ' ';
  } while ( prim < max );
  cout << '\n';

  return 0;
}
