/*
 * 4.2.2. Clasa heap<T>. Fisierul header.
 */

#ifndef __HEAP_H
#define __HEAP_H

#include <iostream.h>
#include <stdlib.h>
#include "tablou.h"

template <class T>
class heap: private tablou<T> {
public:
  heap( int d ): tablou<T>( d ) { h = -1; }
  heap( const tablou<T>& t ): tablou<T>( t )
    { h = t.size( ) - 1; make_heap( ); }

  insert    ( const T& );
  delete_max(       T& );

protected:
  int h;      // indicele ultimului element din heap

  void percolate( int );
  void sift_down( int );
  void make_heap( );
};

template <class T>
heap<T>::insert( const T& v ) {
  if ( h >= d - 1 ) return 0;
  a[ ++h ] = v; percolate( h );
  return 1;
}

template <class T>
heap<T>::delete_max( T& v ) {
  if ( h < 0 ) return 0;
  v = a[ 0 ];
  a[ 0 ] = a[ h-- ]; sift_down( 0 );
  return 1;
}

template <class T>
void heap<T>::make_heap( ) {
  for ( int i = (h + 1) / 2; i >= 1; sift_down( --i ) );
}

template <class T>
void heap<T>::percolate( int i ) {
  T *A = a - 1;  // a[ 0 ]     este A[ 1 ], ..., 
                 // a[ i - 1 ] este A[ i ]
  int k = i + 1, j;

  do {
    j = k;
    if ( j > 1 && A[ k ] > A[ j/2 ] ) k = j/2;
    T tmp = A[ j ]; A[ j ] = A[ k ]; A[ k ] = tmp;
  } while ( j != k );
}

template <class T>
void heap<T>::sift_down( int i ) {
  T *A = a - 1;  // a[ 0 ]     este A[ 1 ], ...,
                 // a[ n - 1 ] este A[ n ]
  int n = h + 1, k = i + 1, j;

  do {
    j = k;
    if ( 2*j <= n && A[ 2*j   ] > A[ k ] ) k = 2*j;
    if ( 2*j <  n && A[ 2*j+1 ] > A[ k ] ) k = 2*j+1;
    T tmp = A[ j ]; A[ j ] = A[ k ]; A[ k ] = tmp;
  } while ( j != k );
}

#endif
