/*
 * 2.3.2. Clasa intErval. Definitiile functiilor membre.
 */

#include "intErval.h"
#include <stdlib.h>

intErval::intErval( int sup, int inf ) {
  if ( inf >= sup ) {
    cerr << "\n\nintErval -- domeniu incorect specificat [ "
         << inf << ", " << (sup - 1) << " ].\n\n";
    exit( 1 );
  }
  min = v = inf;
  max =     sup;
}

int intErval::verDom( int i ) {
  if ( i < min || i >= max ) {
    cerr << "\n\nintErval -- "
         << i << ": valoare exterioara domeniului [ "
         << min << ", " << (max - 1) << " ].\n\n";
    exit( 1 );
  }
  return i;
}

intErval& intErval::operator =( const intErval& s ) {
  min = s.min; v = s.v; max = s.max;
  return *this;
}

istream& operator >>( istream& is, intErval& n ) {
  int i;
  if ( is >> i )  // se citeste valoarea
    n = i;        // se invoca operatorul de atribuire
  return is;
}

/*
 * Secventa de test pentru clasa intErval.
 *

int main( ) {
  intErval indice, numar( 32, 80);

  cin >> numar >> indice;

  indice = (int)numar + 1;
  indice = numar + 1;

  return 1;
}

 *
 *
 */