/*
 * 4.2.2. Clasa intErval si manipularea obiectelor const.
 *
 *                                  Se  utilizeaza clasa intErval.
 *
 * Acest program poate fi rulat in doua variante:
 *
 * 1. Folosind forma incompleta a clasei intErval (varianta implicita).
 *    Aceasta varianta ilustreaza deficientele discutate in Sectiunea 4.2.2
 *    Selectarea acestei varinte se face eliminand linia
 *    #include "intErval.h"
 */

// #include "intErval.h"

/*
 * 2. Folosind forma completa a clasei intErval din fisierele
 *    INTERVAL.H si INTERVAL.CPP.
 *    Pentru link-editare este necesar fisierul proiect INTERVCT.PRJ.
 *    Selectarea acestei varinte se face introducand linia
 *    #include "intErval.h"
 */

#ifndef __INTeRVAL_H

#include <iostream.h>
#include <stdlib.h>

/*
 * Clasa intErval - forma incompleta
 */

class intErval {
public:
  intErval( int = 1, int = 0 );
  ~intErval( ) { }

  int operator =( int i ) { return v = verDom( i ); }
  operator int( ) { return v; }

private:
  int verDom( int );

  int min, max;
  int v;
};

intErval::intErval( int sup, int inf ) {
  if ( inf >= sup ) {
    cerr << "\n\nintErval -- domeniu incorect specificat [ "
         << inf << ", " << (sup - 1) << " ].\n\n";
    exit( 1 );
  }
  min = v = inf;
  max =     sup;
}

int intErval::verDom( int i ) {
  if ( i < min || i >= max ) {
    cerr << "\n\nintErval -- "
         << i << ": valoare exterioara domeniului [ "
         << min << ", " << (max - 1) << " ].\n\n";
    exit( 1 );
  }
  return i;
}

istream& operator >>( istream& is, intErval& n ) {
  int i;
  if ( is >> i )  // se citeste valoarea
    n = i;        // se invoca operatorul de atribuire
  return is;
}

#else
#include "intErval.h"
#endif


int main( ) {
  intErval       x1;
  const intErval x2( 20, 10 );

  x1 = x2;
  return 0;
}

