/*
 * 6.7. Algoritmul lui Kruskal.
 *
 * Pentru link-editare este necesar fisierul proiect KRUSKAL.PRJ
 */

#include <iostream.h>
#include "muchie.h"
#include "set.h"
#include "heap.h"

tablou<muchie> Kruskal( int n, const tablou<muchie>& M ) {
  heap<muchie> h( M );

  tablou<muchie> A( n - 1 ); int nA = 0;
  set            s( n );

  do {
    muchie m;
    if ( !h.delete_max( m ) )
      { cerr << "\n\nKruskal -- heap vid.\n\n"; return A = 0; }

    int ucomp = s.find3( m.u ), vcomp = s.find3( m.v );

    if ( ucomp != vcomp ) {
      s.merge3( ucomp, vcomp );
      A[ nA++ ] = m;
    }
  } while ( nA != n - 1 );

  return A;
}

main( ) {
  int n;
  cout << "\nVarfuri... ";
  cin >> n;

  tablou<muchie> M;
  cout << "\nMuchiile si costurile lor... ";
  cin >> M;

  cout << "\nArborele de cost minim Kruskal:\n";
  cout <<  Kruskal( n, M ) << '\n';
  return 1;
}

