/*
 * 4.1.2. Clasa neparametrica "tablou de intregi".
 */

#include <iostream.h>

class tablou {
public:
  // constructorii si destructorul
  tablou( int = 0 );       // constructor (numarul de elemente)
  tablou( const tablou& ); // constructor de copiere
 ~tablou( )  { delete a; } // elibereaza memoria alocata

  // operatori de atribuire si indexare
  tablou& operator =( const tablou& );
  int& operator []( int );

  // returneaza numarul elementelor
  size( ) { return d; }

private:
  int  d; // numarul elementelor (dimensiunea) tabloului
  int *a; // adresa zonei alocate

  // functie auxiliara de initializare
  void init( const tablou& );
};

tablou::tablou( int dim  ) {
  a = 0; d = 0;               // valori implicite
  if ( dim > 0 )              // verificarea dimensiunii
    a = new int [ d = dim ];  // alocarea memoriei
}

tablou::tablou( const tablou& t ) {
  // initializarea obiectului invocator cu t
  init( t );
}

tablou& tablou::operator =( const tablou& t ) {
  if ( this != &t ) { // este o atribuire inefectiva x = x?
    delete a;         // eliberarea memoriei alocate
    init( t );        // initializarea cu t
  }
  return *this;       // se returneaza obiectul invocator
}

void tablou::init( const tablou& t ) {
  a = 0; d = 0;              // valori implicite
  if ( t.d > 0 ) {           // verificarea dimensiunii
    a = new int [ d = t.d ]; // alocarea si copierea elem.
    memcpy( a, t.a, d * sizeof( int ) );
  }
}

int& tablou::operator []( int i ) {
  static int z; // "elementul" tablourilor de dimensiune zero
  return d? a[ i ]: z;
}


main( ) {

  int n = 8;
  tablou x( n ), y, z( 100 );

  for ( n = 0; n < x.size( ); n++ )
    x[ n ] = n;

  cout << '\n';
  cout << "\nx (initializat  ): ";
  for ( n = 0; n < x.size( ); n++ )
    cout << x[ n ] << ' ';

  cout << "\ny (neinitializat): ";
  for ( n = 0; n < y.size( ); n++ )
    cout << y[ n ] << ' ';

  y = z = x;
  cout << "\ny (y = z = x    ): ";
  for ( n = 0; n < y.size( ); n++ )
    cout << y[ n ] << ' ';

  y = n / 2;
  cout << "\ny (y = n/2      ): ";
  for ( n = 0; n < y.size( ); n++ )
    cout << y[ n ] << ' ';

  cout << '\n';
  return 1;
}
