/*
 * 10.2.2. Tablou initializat virtual, tablouVI<T>. Fisierul header.
 *
 *    S-a introdus functia tip( ) pentru RTTI (Sectiunea 10.2.3).
 */

#ifndef __TABLOUvi_H
#define __TABLOUvi_H

#include "tablou.h"

template <class T>
class tablouVI: public tablou<T> {
public:
  tablouVI( int, T );

  tablouVI& operator =( T );
  T& operator []( int );

  // RTTI (Sectiunea 9.7.2.3)
  char tip( ) const { return 'V'; }

private:
  T vi;             // valoarea implicita

  tablou<int> p, b; // tablourile auxiliare p si b
  int sb;           // pointer in b
};

template<class T>
T& tablouVI<T>::operator []( int i) {
  static T z;   // elementul returnat in caz de eroare

  // verificarea indicelui i
  if ( i < 0 || i >= d ) {
    cerr << "\n\ntablouIV -- " << d
         << ": indice eronat: " << i << ".\n\n";
    return z;
  }

// returnarea valorii elementului i
  int k = p[ i ];
  if ( 0 <= k && k <= sb && b[ k ] == i )
    // element deja initializat
    return a[ i ];
  else
    // elementul se initializeaza cu valoarea implicita
    return a[ b[ p[ i ] = ++sb ] = i ] = vi;
}

template<class T>
tablouVI<T>& tablouVI<T>::operator =( T v ) {
  vi = v; sb = -1;
  return *this;
}

template<class T>
tablouVI<T>::tablouVI( int n, T v ):
            tablou<T>( n ), vi( v ), p( n ), b( n ), sb( -1 ) {
}

#endif
